function PunkteAnzeige()
{
	my.passable = on;
	
	my.scale_x = 0.2;
	my.scale_y = 0.2;
	my.scale_z = 0.2;
	
	wait(2);
	
	while(SpielLauft)
	{
		you = my.parent;
		vec_set(my.x,vector(you.x,you.y,you.z+60));
		my.frame = you.Punkte;
		
		wait(1);
	}
	wait(1);
	ent_remove(me);
}


function Unsterblich(Zeit)
{
	my.RespawnCheckFlag = on;
	wait(-Zeit);
	my.RespawnFlag = off;
	my.RespawnCheckFlag = off;
}

Function PartSprung_spec_fun()
{
    my.alpha -= 5 *time_step;
    IF(My.alpha < 0) { my.alpha = 0; my.lifespan = 0; }
}

Function PartSprungspezial()
{
    my.blue = you.blue;
    my.green = you.green;
    my.red = you.red;
    my.vel_x = random( 2 ) - 1;
    my.vel_y = random( 2 ) - 1;
    my.vel_z = random( -5 );
    my.size = 3;
    my.alpha = 50;
    my.gravity = 0;
    my.streak = off;
    my.flare = on;
    my.bright = on;
    my.beam = off;
    my.move = on;
    my.transparent = on;
    my.function = PartSprung_spec_fun;
}

Function PartLande_spec_fun()
{
    my.alpha -= 3 * time_step;
    IF(My.alpha < 0) { my.alpha = 0; my.lifespan = 0; }
}

Function PartLandespezial()
{
    my.blue = 128 ;
    my.green = 128 ;
    my.red = 128 ;
    my.bmap = PartLandeBmap;  //the effect bitmap
    my.vel_x = random( 5 ) - 2.500;
    my.vel_y = random( 5 ) - 2.500;
    my.vel_z = 0;
    my.size = 2;
    my.alpha = 50;
    my.gravity = 0;
    my.streak = off;
    my.flare = on;
    my.bright = on;
    my.beam = off;
    my.move = on;
    my.transparent = on;
    my.function = PartLande_spec_fun;
}

//uses: SpielerID, Sprunghohe, Geschwindigkeit, Unsterblichkeit, PartikelVertex
action Spieler()
{
	if(!my.SpielerID)
	{
		my.SpielerID = SpielerIDs;
		SpielerIDs += 1;
	}
	
	if(!my.Sprunghohe){my.Sprunghohe = AllSprunghohe;}
	if(!my.Geschwindigkeit){my.Geschwindigkeit = AllGeschwindigkeit;}
	if(!my.Unsterblichkeit){my.Unsterblichkeit = AllUnsterblichkeit;}
	if(!my.PartikelVertex){my.PartikelVertex = AllPartikelVertex;}
	
	SpielerHandles[my.SpielerID] = my;
	
	my.EntMaterial = MatGegner;
	
	my.light = on;
	my.red = 255*(my.SpielerID == 0);
	my.green = 255*(my.SpielerID == 1);
	my.blue = 255*(my.SpielerID == 2);
	
	my.polygon = on;
	c_setminmax(my);
	
	vec_set(my.SpawnPos,my.x);
	
	while(SpielLauft)
	{
		my.MoveSide = (key_pressed(KeyRechts[my.SpielerID])-key_pressed(KeyLinks[my.SpielerID]))*time_step*my.Geschwindigkeit;
		
		vec_for_vertex(my.PartikelVertexPos,my,my.PartikelVertex);
		
		my.Falltiefe = c_trace(my.x,vector(my.x,my.y,my.z-100000),use_box|ignore_me|ignore_passents|ignore_passable);
		if(my.Falltiefe > 5 || my.MoveUpDown > 0)
		{
			my.MoveUpDown -= time_step;
		}else
		{
			if(my.Falltiefe < 0)
			{
				my.MoveUpDown += time_step;
			}else
			{
				if(my.MoveUpDown < -5)
				{
					effect(PartLandespezial,PartLandeAnzahlPartikel,my.PartikelVertexPos,nullvector);
					ent_playsound(my,sndLanden,1000);
					
					
					if(you)
					{
						if (you.EntMaterial == MatGegner && my.Falltiefe < 7 && my.Falltiefe > 0 && you.RespawnFlag == off && you.MoveUpDown == 0)
						{
							you.RespawnFlag = on;
							my.Punkte += 1;
							ent_playsound(my,sndCrash,1000);
							if(my.Punkte == 10)
							{
								SpielerNummer = my.SpielerID;
								Gewonnen();
							}
						}
					}
				}
				my.MoveUpDown = 0;
			}
		}
		
		if(my.RespawnFlag && my.RespawnCheckFlag == off)
		{
			vec_set(my.x,my.SpawnPos);
			Unsterblich(my.Unsterblichkeit);
		}
		
		if(!key_pressed(KeySprung[my.SpielerID]) && my.MoveUpDown == 0){my.SprungFlag = off;}
		if(key_pressed(KeySprung[my.SpielerID]) && my.Falltiefe < 5 && my.SprungFlag == off)
		{
			my.MoveUpDown = my.Sprunghohe;
			my.SprungFlag = on;
			
			ent_playsound(my,sndSprung,1000);
		}
		
		if(my.MoveUpDown != 0)
		{
			effect(PartSprungspezial,PartSprungAnzahlPartikel,my.PartikelVertexPos,nullvector);
		}
		
		my.pan = -90 + 90 * sign(my.MoveSide);
		my.MoveSide *= sign(my.MoveSide);
		
		c_move(my,my.MoveSide,nullvector,glide|ignore_passable|ignore_passents);
		
		my.y = 0;
		
		if(my.PointFlag == off && my.Punkte == 1)
		{
			you = ent_create(PunkteSprite,my.x,PunkteAnzeige);
			you.parent = my;
			
			my.PointFlag = on;
		}
		
		wait(1);
	}
	
	wait(1);
	ent_remove(me);
}

//uses: SpielerID, Sprunghohe, Geschwindigkeit, Unsterblichkeit, PartikelVertex
action Erstelle_Spieler()
{
	my.passable = on;
	my.invisible = on;
	
	str_for_entfile(PlayerModell,my);
	while(my.SpielerID < SpielerZahl)
	{
		wait(-2);
		you = ent_create(PlayerModell,my.x,Spieler);
		you.SpielerID = my.SpielerID;
		you.Sprunghohe = my.Sprunghohe;
		you.Geschwindigkeit = my.Geschwindigkeit;
		you.Unsterblichkeit = my.Unsterblichkeit;
		you.PartikelVertex = my.PartikelVertex;
		
		my.SpielerID += 1;
	}
	
	wait(1);
	ent_remove(me);
}