function SLX3_4XDownsample()
{
	if(SLX3_PostProcessing > 9){return(0);}
	SLX3ViewSetPostProcessing(20,0);
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing,SLX3_PPE_4XDOWNSAMPLE);
	if(SLX3_PostProcessing < 9)
	{
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing+1,0);
	}
	SLX3ViewSetPostProcessing(20,1);

	SLX3_PostProcessing += 1;
}

function SLX3_2XDownsample()
{
	if(SLX3_PostProcessing > 9){return(0);}
	SLX3ViewSetPostProcessing(20,0);
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing,SLX3_PPE_4XDOWNSAMPLE);
	if(SLX3_PostProcessing < 9)
	{
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing+1,0);
	}
	SLX3ViewSetPostProcessing(20,1);

	SLX3_PostProcessing += 1;
}

function SLX3_Upsample()
{
	if(SLX3_PostProcessing > 9){return(0);}
	SLX3ViewSetPostProcessing(20,0);
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing,SLX3_PPE_4XDOWNSAMPLE);
	if(SLX3_PostProcessing < 9)
	{
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing+1,0);
	}
	SLX3ViewSetPostProcessing(20,1);

	SLX3_PostProcessing += 1;
}

function SLX3_Bloom(HBLOOM,VBLOOM)
{	
	if(SLX3_PostProcessing > 4){return(0);}
	SLX3ViewSetPostProcessing(20,0);

	// Set Bloom
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing,SLX3_PPE_BRIGHTPASS);
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing+1,SLX3_PPE_HBLOOM);
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing+2,SLX3_PPE_VBLOOM);
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing+3,SLX3_PPE_COMBINE);
	if(SLX3_PostProcessing < 4)
	{
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing+4,0);
	}
	
	SLX3ViewSetPostProcessing(20,1);

	// Set Bloomstrength
	SLX3EffectSetValue(SLX3_PPE_HBLOOM,0,HBLOOM);
	SLX3EffectSetValue(SLX3_PPE_VBLOOM,0,VBLOOM);
	
	SLX3_PostProcessing += 4;
}

function SLX3_Bloom_Strength(HBLOOM,VBLOOM)
{
	// Set Bloomstrength
	SLX3EffectSetValue(SLX3_PPE_HBLOOM,0,HBLOOM);
	SLX3EffectSetValue(SLX3_PPE_VBLOOM,0,VBLOOM);
}

function SLX3_Blur(HBLUR,VBLUR)
{
	if(SLX3_PostProcessing > 8){return(0);}
	SLX3ViewSetPostProcessing(20,0);
	
	// Set Blur
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing,SLX3_PPE_HBLUR);
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing+1,SLX3_PPE_VBLUR);
	if(SLX3_PostProcessing < 8)
	{
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing+2,0);
	}
		
	SLX3ViewSetPostProcessing(20,1);
	
	// Set Blurstrength
	SLX3EffectSetValue(SLX3_PPE_HBLUR,0,HBLUR);
	SLX3EffectSetValue(SLX3_PPE_VBLUR,0,VBLUR);
	
	SLX3_PostProcessing += 2;
}

function SLX3_Blur_Strength(HBLUR,VBLUR)
{
	// Set Blurstrength
	SLX3EffectSetValue(SLX3_PPE_HBLUR,0,HBLUR);
	SLX3EffectSetValue(SLX3_PPE_VBLUR,0,VBLUR);
}

function SLX3_Monochrom()
{
	if(SLX3_PostProcessing > 9){return(0);}
	SLX3ViewSetPostProcessing(20,0);
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing,SLX3_PPE_MONOCHROM);
	if(SLX3_PostProcessing < 9)
	{
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing+1,0);
	}
	SLX3ViewSetPostProcessing(20,1);

	SLX3_PostProcessing += 1;
}

function SLX3_InvertColor()
{
	if(SLX3_PostProcessing > 9){return(0);}
	SLX3ViewSetPostProcessing(20,0);
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing,SLX3_PPE_INVERTCOLOR);
	if(SLX3_PostProcessing < 9)
	{
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing+1,0);
	}
	SLX3ViewSetPostProcessing(20,1);

	SLX3_PostProcessing += 1;
}

function SLX3_SimpleBlur()
{
	if(SLX3_PostProcessing > 9){return(0);}
	SLX3ViewSetPostProcessing(20,0);
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing,SLX3_PPE_SIMPLEBLUR);
	if(SLX3_PostProcessing < 9)
	{
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing+1,0);
	}
	SLX3ViewSetPostProcessing(20,1);

	SLX3_PostProcessing += 1;
}

function SLX3_PPE_Reset()
{
	SLX3_PostProcessing = 0;

	SLX3ViewSetPostProcessing(20,0);
	SLX3ViewSetPostProcessingEffect(20,SLX3_PostProcessing,0);

	while(SLX3_PPE_Register > 0)
	{
		SLX3EffectDelete(SLX3_PPE_Register);
		SLX3_PPE_Register -= 1;
	}
	while(SLX3_PPETex_Register > 0)
	{
		SLX3TexDelete(SLX3_PPETex_Register);
		SLX3_PPETex_Register -= 1;
	}
}