path "Sylex3";

include <Sylex3_csr.wdl>;

var SLX3_PostProcessing = 0;

var SLX3_Rain_Flag = 0;
var SLX3_PPE_Register = 0;
var SLX3_PPETex_Register = 0;

function SLX3_VideoSwitch(Mode,Depth,Window)
{
	// Shows Sylex 3 videomode to use
	SLX3SwitchResolution(Mode); 
	// Changes the Acknex 6 Videomode
	video_switch(Mode,Depth,Window);
}

function SLX3_Init(Titel)
{
	// Initialize Sylex 3.0 
	SLX3Initialize(SLX3_RUNMODE_RELEASE,Titel);
	
	// Register the view called camera
	SLX3ViewRegister(20,"camera");
}

// Userdefined exitfunction with closing Sylex 3.0 
function userdef_exit()
{
	// Sylex 3.0 Deinitialize
	SLX3DeInitialize();

	// free functionpointers
	on_d3d_lost = NULL; 
	on_d3d_reset = NULL; 

	// Quit Acknex 6 Engine 
	sys_exit("bye bye ..."); 
} 

//Keydefinitions: 
ON_ESC = NULL;
ON_CLOSE = userdef_exit;
ON_F10 = userdef_exit;


include <SLX3_PostProcessing.wdl>;